/*******************************************************************************
 *
 * File Name: rulesClass.h
 * Author: Richard Baxter
 * Project: Generic Construct Functions
 * Project Version: 3d1d 19-Jan-07
 *
 *******************************************************************************/

#ifndef RULES_CLASS
#define RULES_CLASS

#include <string>
#include <iostream>
#include <fstream>
#include <time.h>
#include <math.h>
using namespace std;

#include "XMLParserClass.h"

#define OLC_PARSER

class RulesClass
{
private:
	/*There are currently no private attributes of this class*/
public:

	RulesClass(void); // constructor
	~RulesClass();	// and destructor.

	string name;	//attribute1;

	string stringValue;	//attribute2;
	double fractionalValue;
	int attribute4;
	int attribute5;
	int attribute6;
	int attribute7;
	int attribute8;

	/*
	int defenceMod;

	int closeCombatAttackMod;
	int mountedAttackBonus;

	int longDistanceAttackMod;
	int longDistanceRange;
	*/

	RulesClass * next;
};
//there really should be child classes of RulesClass called rulesUnitTypeDetails, unitCombatDetailsAttack, and unitCombatDetailsDefence that inherit rulesObject and include unique parameters


/*
struct XMLTagAttributes
{
	int fractionalValue;
	int numberOfPartsInUnit;

	int defenceMod;

	int closeCombatAttackMod;
	int mountedAttackBonus;

	int longDistanceAttackMod;
	int longDistanceRange;
};
typdef XMLTagAttributes objectAttributes
*/

//High Level
bool parseRulesXMLFile();
	bool parseRulesTag(XMLParserTag * currentTag);
	#ifndef OLC_PARSER
		bool parseTagUnitCombatDetails(XMLParserTag * currentTag);
			bool parseTagArmour(XMLParserTag * currentTag);
				bool parseTagHead(XMLParserTag * currentTag);
				bool parseTagTorso(XMLParserTag * currentTag);
				bool parseTagShield(XMLParserTag * currentTag);
			bool parseTagWeapons(XMLParserTag * currentTag);
				bool parseTagCloseCombat(XMLParserTag * currentTag);
				bool parseTagLongDistanceCombat(XMLParserTag * currentTag);
		bool parseTagOther();
	#endif


XMLParserTag * parseTagDownALevel(XMLParserTag * currentTag, string sectionTagName, bool * result);
bool addRulesClassObjectsBasedOnSectionTag(XMLParserTag * currentTag, string sectionTagName, RulesClass * firstReferenceToObjectClass, string tagName, int numberOfAttributes, string attribute1Name, string attribute2Name, string attribute3Name, string attribute4Name, string attribute5Name, string attribute6Name, string attribute7Name, string attribute8Name);
bool addRulesClassObjectBasedOnTag(XMLParserTag * currentTag, RulesClass * currentReferenceToObjectClass, string tagName, int numberOfAttributes, string attribute1Name, string attribute2Name, string attribute3Name, string attribute4Name, string attribute5Name, string attribute6Name, string attribute7Name, string attribute8Name);


//bool parseSectionTagAndAddObjectsWithAttributes(RulesClass * firstReferenceToObjectClass, string parentTagName, int numberOfAttributes, string attribute1Name, string attribute2Name, string attribute3Name, string attribute4Name, string attribute5Name, string attribute6Name, string attribute7Name, string attribute8Name);
//bool parseTagAndAddObjectWithAttributes(RulesClass * firstReferenceToObjectClass, int numberOfAttributes, string attribute1Name, string attribute2Name, string attribute3Name, string attribute4Name, string attribute5Name, string attribute6Name, string attribute7Name, string attribute8Name);

#ifndef OLC_PARSER
extern RulesClass * rulesUnitTypeDetails;
extern RulesClass * rulesUnitCombatDetailsDefenceHead;
extern RulesClass * rulesUnitCombatDetailsDefenceTorso;
extern RulesClass * rulesUnitCombatDetailsDefenceShield;
extern RulesClass * rulesUnitCombatDetailsAttackCloseCombat;
extern RulesClass * rulesUnitCombatDetailsAttackLongDistance;
extern RulesClass * rulesBuildingDetails;
extern RulesClass * rulesTerrainDetails;
extern RulesClass * rulesUnitTypeCatagories;
extern RulesClass * rulesMiscellaneous;
#endif
extern RulesClass * rulesSprite;


#endif